/*
 * N64 GLTCgoCN64 bZ[WRo[^[
 * 
 *
 */
#include <stdio.h>
#include <string.h>

#define TBLFILE      "eb64.tbl"    //e[ut@Cw
#define TBLFILE_KANJI  "eb64k.tbl"    //e[ut@Cw
#define VERSION "1.0"        //o[Wio[

FILE *fp, *fpt;            // t@C|C^
unsigned int iGetFile = 0;    // [hf[^i[p
unsigned char table[256][3];    // e[upobt@
unsigned char table_kanji[256][3];    // e[upobt@
void MsgConv(unsigned long, unsigned long);

const unsigned int SaveID_0 = 0x23D8A6C8;   // Main save state info (*.pj)
const unsigned char header_CRC[8]  = {0x19, 0x35, 0x1C, 0x86, 0xE5, 0x1C, 0x09, 0xF6};
const unsigned char header_NAME[20] = {0x49, 0x43, 0x58, 0x45, 0x49, 0x42, 0x45, 0x54, 0x34, 0x36, 0x45, 0x4B, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20}; //"ICXEIBET46EK        "





/* Struct of PJ64 savestatefile */
/*
00000000    4byte    Magc Word = C8 A6 D8 23
00000004    4byte    RDRAMSize

00000010    64byte    J[gbŴ݂̏ꍇ
                        64byte    ROM Header info from B0000000-B000003F
                    fBXN̏ꍇ
                        32byte    ROM Header info from B0000000-B000001F
                        32byte    DiskAddressID
                        
NextVITimer, sizeof(NextVITimer)
m_Reg.m_PROGRAM_COUNTER
m_Reg.m_GPR, sizeof(int64_t) * 32);
m_Reg.m_FPR, sizeof(int64_t) * 32);
m_Reg.m_CP0, sizeof(uint32_t) * 32);
m_Reg.m_FPCR, sizeof(uint32_t) * 32);
m_Reg.m_HI, sizeof(int64_t));
m_Reg.m_LO, sizeof(int64_t));
m_Reg.m_RDRAM_Registers, sizeof(uint32_t) * 10);
m_Reg.m_SigProcessor_Interface, sizeof(uint32_t) * 10);
m_Reg.m_Display_ControlReg, sizeof(uint32_t) * 10);
m_Reg.m_Mips_Interface, sizeof(uint32_t) * 4);
m_Reg.m_Video_Interface, sizeof(uint32_t) * 14);
m_Reg.m_Audio_Interface, sizeof(uint32_t) * 6);
m_Reg.m_Peripheral_Interface, sizeof(uint32_t) * 13);
m_Reg.m_RDRAM_Interface, sizeof(uint32_t) * 8);
m_Reg.m_SerialInterface, sizeof(uint32_t) * 4);
m_TLB.TlbEntry(0), sizeof(CTLB::TLB_ENTRY) * 32);
m_MMU_VM.PifRam(), 0x40);
m_MMU_VM.Rdram(), SaveRDRAMSize);
m_MMU_VM.Dmem(), 0x1000);
m_MMU_VM.Imem(), 0x1000);
*/

int main(int argc, char* argv[])
{
    unsigned long i = 0;// JE^
    unsigned char LoadHeader[72];

    /*\tg^Cg*/
    printf("-- N64 Excitebike 64 Message Converter V%s --\n", VERSION);
    printf("Original by Imaha486,Hacked by Nekokabu\n");
    
    /*Ȃꍇ*/
    if(argc==1){
        printf(" usage:cnv_eb64 excitebike64.pj\n");
        return 0;
    }
    
    ////////////////////////////////
    //e[ut@Cǂݍ
    
    /*e[ut@CI[v*/
    if((fpt = fopen(TBLFILE, "rb")) == NULL){
        printf("table data not found.\n");
        return 0;
    }

    // e[uobt@Ƀ[h
    for(i = 0; i <= 255; i ++){
        fread(&table[i], 2, 1, fpt);
        table[i][2] = '\0'; // NULL}
        //printf("%s",table[i]);
    }
    if(fpt != NULL)    fclose(fpt);

    
    ////////////////////////////////
    //e[ut@Cǂݍ
    
    /*e[ut@CI[v*/
    if((fpt = fopen(TBLFILE_KANJI, "rb")) == NULL){
        printf("KANJI table data not found.\n");
        return 0;
    }
    // e[uijobt@Ƀ[h
    for(i = 0; i <= 255; i ++){
        fread(&table_kanji[i], 2, 1, fpt);
        table_kanji[i][2] = '\0'; // NULL}
        //printf("%s",table_kanji[i]);
    }
    if(fpt != NULL)    fclose(fpt);
    
    


    /*ꍇA\[Xt@CI[v*/
    if((fp = fopen(argv[1], "rb")) == NULL){
        printf("file %s not found.\n", argv[1]);
        return 0;
    }

    //////////////////////////////////
    // 擪72oCgǂݍ
    fseek(fp, 0x0L, SEEK_SET);
    fread(LoadHeader, 1, 72, fp);
    
    //////////////////////////////////
    // w肳ꂽt@CPJ64 savestate file`FbN
    if(*(unsigned int*)LoadHeader !=  SaveID_0){
        printf("%s are not PJ64 Savestate File.\n", argv[1]);
        if(fp != NULL)    fclose(fp);
        return 0;
    }
    
    //////////////////////////////////
    // w肳ꂽPJ64 savestate fileGLTCgoCN64(J)̂̂`FbN
    // CRCƃŔ
    if((memcmp((unsigned char*)(LoadHeader+0x18), header_CRC, 8) != 0) || (memcmp((unsigned char*)(LoadHeader+0x28), header_NAME, 20) != 0)){
        printf("%s are not EXCITEBIKE64 (J) Statesave.\n", argv[1]);
        if(fp != NULL)    fclose(fp);
        return 0;
    }
    else{
        printf("%s are Excitebike 64 (J) Statesave.\n", argv[1]);
    }
    
    
    // bZ[WϊJn
    MsgConv(0x000CA17C, 0x000cc824);
    
    if(fp != NULL)    fclose(fp);

    return 0;
}

/*̕ϊ*/
void MsgConv(unsigned long StartAdr,unsigned long EndAdr){
    unsigned long i = 0;
    int tmp = 0;
    
    
    for(i = StartAdr; i <= EndAdr; i ++){
        
        //SoCgPʂŃf[^]Ă̂ŃAhX𔽓]
        fseek(fp, i ^ 3, SEEK_SET);
        iGetFile = getc(fp);
        switch(iGetFile){
            case 0x0: //I[
                printf("\n");
                break;
            case 0xE: //\:
                //SoCgPʂŃf[^]Ă̂ŃAhX𔽓]
                fseek(fp, ++i ^ 3, SEEK_SET);
                tmp = getc(fp);
                switch(tmp){
                    case 0xFA:
                    case 0xFB:
                    case 0xFC:
                    case 0xFD:
                    case 0xFE:
                    case 0xFF:
                        break;
                    default:
                        printf("%s",table_kanji[tmp]);
                        break;
                }
                break;
            default: // e[u璼ڏo
                printf("%s",table[iGetFile]);
                break;
        }
    }
}
